// CountDots2View.cpp : implementation of the CCountDots2View class
//

#include "stdafx.h"
#include "CountDots2.h"

#include "CountDots2Doc.h"
#include "CountDots2View.h"
#include "mainfrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCountDots2View

IMPLEMENT_DYNCREATE(CCountDots2View, CView)

BEGIN_MESSAGE_MAP(CCountDots2View, CView)
	//{{AFX_MSG_MAP(CCountDots2View)
	ON_COMMAND(ID_BUTTON32771, OnButton32771)
	ON_WM_LBUTTONDBLCLK()
	ON_WM_CREATE()
	ON_WM_DROPFILES()
	ON_WM_RBUTTONUP()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_MENUITEM32773, OnMenuitem32773)
	ON_COMMAND(ID_MENUITEM32774, OnMenuitem32774)
	ON_COMMAND(ID_MENUITEM32775, OnMenuitem32775)
	ON_COMMAND(ID_BUTTON32776, OnButton32776)
	ON_COMMAND(ID_BUTTON32777, OnButton32777)
	ON_COMMAND(ID_BUTTON32778, OnButton32778)
	ON_COMMAND(ID_MENUITEM32782, OnMenuitem32782)
	ON_COMMAND(ID_BUTTON32783, OnButton32783)
	ON_COMMAND(ID_BUTTON32784, OnButton32784)
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_SETCURSOR()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCountDots2View construction/destruction

CCountDots2View::CCountDots2View()
{
	// TODO: add construction code here

}

CCountDots2View::~CCountDots2View()
{
}

BOOL CCountDots2View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CCountDots2View drawing

void CCountDots2View::OnDraw(CDC* pDC)
{
	CCountDots2Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->DrawToDC(pDC->GetSafeHdc(),pDC);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CCountDots2View printing

BOOL CCountDots2View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CCountDots2View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CCountDots2View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CCountDots2View diagnostics

#ifdef _DEBUG
void CCountDots2View::AssertValid() const
{
	CView::AssertValid();
}

void CCountDots2View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CCountDots2Doc* CCountDots2View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCountDots2Doc)));
	return (CCountDots2Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCountDots2View message handlers

void CCountDots2View::OnButton32771() 
{
	// TODO: Add your command handler code here
	CCountDots2Doc *pDoc=this->GetDocument();
	pDoc->countcolor=true;
	AfxMessageBox("Please Load the image and then double click the color you want to count");

//	SetCursor(LoadCursor(AfxGetInstanceHandle(),(LPCTSTR)IDC_CURR1));
	
}

void CCountDots2View::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CCountDots2Doc *pDoc=this->GetDocument();
	int count=pDoc->CountDotsSameAs(point);
	AfxMessageBox("Count Result:"+pDoc->str(count));
	CView::OnLButtonDblClk(nFlags, point);
}

int CCountDots2View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	this->DragAcceptFiles();
	this->SetIcon(LoadIcon(AfxGetInstanceHandle(),(LPCTSTR)IDR_MAINFRAME),FALSE);
	
	// TODO: Add your specialized creation code here

	return 0;
}

void CCountDots2View::OnDropFiles(HDROP hDropInfo) 
{
	// TODO: Add your message handler code here and/or call default
	CCountDots2Doc *pDoc=this->GetDocument();
	int number_of_file=DragQueryFile(         hDropInfo,
    0xffffffff,
    NULL, 0
	);
	char name[1000];
	for(int n=0;n<number_of_file;n++)
	{
		DragQueryFile(hDropInfo,n,name,1000);
		pDoc->AddFileToDeque(name);
	}
	pDoc->LoadImag((*pDoc->filenames.begin()));
	InvalidateRect(NULL);
	CView::OnDropFiles(hDropInfo);
}

void CCountDots2View::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CCountDots2Doc *pDoc=this->GetDocument();

	cm.CreatePopupMenu();

	int n;
	n=0;
	set<CString>::iterator i;
	if(pDoc->filenames.empty())
	cm.InsertMenu(0,MF_BYPOSITION|MF_STRING|MF_GRAYED,WM_USER+10000,"(Currently No File)");	
	else
	cm.InsertMenu(0,MF_BYPOSITION|MF_STRING|MF_GRAYED,WM_USER+10000,(const char*)((CString)"("+pDoc->str(pDoc->filenames.size())+"files)"));	

	for(i=pDoc->filenames.begin();
		i!=pDoc->filenames.end();
		i++)
		{

		cm.InsertMenu(n,MF_BYPOSITION|MF_STRING,WM_USER+n,(*i));
		n++;
		
		}
	
	POINT pt;
	pt.x=point.x;
	pt.y=point.y;
	ClientToScreen(&pt);

	cm.TrackPopupMenu(TPM_LEFTALIGN,pt.x,pt.y,this);
	cm.DestroyMenu();
	CView::OnRButtonUp(nFlags, point);
}

void CCountDots2View::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// TODO: Add your message handler code here
	
}

BOOL CCountDots2View::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	UINT idCommand=LOWORD(wParam);
	UINT idOffset;
	idOffset=idCommand-WM_USER;
	CString st;
	set<CString>::iterator i;
	int k;
	if(idOffset>=0)

	{
		 
			CCountDots2Doc *pDoc=this->GetDocument();
			//cm.GetMenuString(idCommand,	st,MF_BYCOMMAND);
		//	AfxMessageBox("idoff:"+pDoc->str(idOffset));
			if(pDoc->filenames.size()<idOffset+1) return TRUE;
			for(k=0,i=pDoc->filenames.begin();k<idOffset;k++,i++);
			st=(*i);
			pDoc->LoadImag(st);
		//	AfxMessageBox(st);
			this->InvalidateRect(NULL);
	}
	
	
	return CView::OnCommand(wParam, lParam);
}

void CCountDots2View::OnMenuitem32773() 
{
	// TODO: Add your command handler code here
			CCountDots2Doc *pDoc=this->GetDocument();
			pDoc->clearOneFile(pDoc->currentname);
}

void CCountDots2View::OnMenuitem32774() 
{
	// TODO: Add your command handler code here
			CCountDots2Doc *pDoc=this->GetDocument();
			pDoc->clearFileDeques();
}

void CCountDots2View::OnMenuitem32775() 
{	
	CFileDialog cf(FALSE,"Plain Text(*.txt)|*.txt",NULL,OFN_OVERWRITEPROMPT,"Plain Text(*.txt)|*.txt");
	if(cf.DoModal()==IDOK)
	{
			CCountDots2Doc *pDoc=this->GetDocument();
			pDoc->CreateTXTReport(cf.GetFileName());
	}
	((CMainFrame*)::AfxGetMainWnd())->m_wndStatusBar.SetWindowText("Ready");
	// TODO: Add your command handler code here
	
}

void CCountDots2View::OnButton32776() 
{
	// TODO: Add your command handler code here
	OnMenuitem32775();
}

void CCountDots2View::OnButton32777() 
{
	// TODO: Add your command handler code here
	OnMenuitem32773();
}

void CCountDots2View::OnButton32778() 
{
	// TODO: Add your command handler code here
	OnMenuitem32774();
}

void CCountDots2View::OnMenuitem32782() 
{
	// TODO: Add your command handler code here
	AfxMessageBox("Help-How to count bubbles in several files and output results as txt?\n"
				  "Step 1 :Drag the files into the window\n"
				  "Step 2 :Click Action->Count all colors\n"
				  "Step 3 :Select Output filename");

}

void CCountDots2View::OnButton32783() 
{
	// TODO: Add your command handler code here
			CCountDots2Doc *pDoc=this->GetDocument();
		set<CString>::iterator i=
			pDoc->filenames.find(pDoc->currentname);
		if(i!=pDoc->filenames.end())
		{
			
			if(i!=pDoc->filenames.begin())
			{	i--;
				pDoc->LoadImag((*i));
		InvalidateRect(NULL);
			}
			
		}
	
}

void CCountDots2View::OnButton32784() 
{
	// TODO: Add your command handler code here

				CCountDots2Doc *pDoc=this->GetDocument();
		set<CString>::iterator i=
			pDoc->filenames.find(pDoc->currentname);
		if(i!=pDoc->filenames.end())
		{
			i++;
			if(i!=pDoc->filenames.end())
			{
				pDoc->LoadImag((*i));
				InvalidateRect(NULL);
			}
			
		}
				
}

void CCountDots2View::Serialize(CArchive& ar) 
{

}


void CCountDots2View::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	CCountDots2Doc *pDoc=this->GetDocument();
	pDoc->DrawToDC(dc.GetSafeHdc(),&dc);
	// TODO: Add your message handler code here
	
	// Do not call CView::OnPaint() for painting messages
}

void CCountDots2View::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
//	SetCapture();
//	SetCursor(LoadCursor(AfxGetInstanceHandle(),(LPCTSTR)IDC_CUR1));
//	ReleaseCapture();

	//SetCursor(LoadCursor(AfxGetInstanceHandle(),(LPCTSTR)IDC_CUR1));
	CView::OnMouseMove(nFlags, point);
}

BOOL CCountDots2View::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	// TODO: Add your message handler code here and/or call default
//	SetCursor(LoadCursor(AfxGetInstanceHandle(),(LPCTSTR)IDC_CUR1));
	return CView::OnSetCursor(pWnd, nHitTest, message);
}
